function dist2 = distSqrdSelf(X)
% Compute the pairwise squared distances in a fast manner
%   X       n x d
%   dist2   n x n, dist2(i,j) = sum((X(i,:)-X(j,:)).^2)

sx = sum(X .^ 2, 2);
dist2 = bsxfun(@plus, sx, bsxfun(@plus, sx', -2 * X * X'));

